// ======================================================================
//
// direct3d_5.h
// jeff grills
//
// copyright 1997 origin systems inc
//
// ======================================================================

#ifndef DIRECT3D_5_H
#define DIRECT3D_5_H

// ======================================================================

class MaterialData_d3d;
#include "DirectDraw.h"
#include <d3d.h>

// ======================================================================

class Direct3d
{
	friend class GL_d3d_5;
	friend class MaterialData_d3d_5;

private:

	struct Driver
	{
		int                 id;

		const DirectDraw::Driver *directDrawDriver;

		// stuff direct3d tells us
		GUID                guid;
		char               *name;
		char               *desc;
		D3DDEVICEDESC       hw;
		D3DDEVICEDESC       sw;
		D3DDEVICEDESC      *primary;

		Driver             *next;

		// stuff we figure out from what direct3d tells us
		bool                isHardware;
		bool                canTexture;
		bool                zBuffer;
		bool                rgbLighting;
		bool                dithering;
		bool                alphaBlending;
		bool                bilinearFiltering;
		bool                stippledAlpha;
	};

private:

	static LPDIRECT3D2      d3d;
	static Driver          *firstDriver;
	static Driver          *lastDriver;
	static int              globalDriverId;

private:

	static HRESULT WINAPI enumDevicesCallback(LPGUID lpGuid,LPSTR lpDeviceDescription, LPSTR lpDeviceName,LPD3DDEVICEDESC lpHWDesc, LPD3DDEVICEDESC lpHELDesc, LPVOID lpContext);

public:

	static void  enumerate(void);
	static void  install(const Driver *driver);
	static void  remove(void);

	static const Driver *getDriver(int id);

	static void  createTextureInfo(LPDIRECTDRAWSURFACE ddsurf, LPDIRECT3DTEXTURE *texture, LPDIRECT3DMATERIAL *material);
};

// ======================================================================

#endif
